



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>iOS中事件的传递和响应者链条</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">iOS中事件的传递和响应者链条</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 13:20:59 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在iOS 开发中，常见的事件有三种类型，分别是：</p>
<p>（1）触摸事件：平常手指在屏幕上滑动，产生的事件都是触摸事件</p>
<p>（2）加速计事件：微信的摇一摇就是典型的加速计事件</p>
<p>（3）远程控制事件：耳机控制歌曲上一首、下一首、暂停就是远程控制事件的应用。</p>
<p>在触摸事件中，通常情况下，点击哪个控件，哪个控件就会产生反应。比如说，点击确定按钮，确定按钮会响应该事件，点击取消按钮，取消按钮会响应该事件。那么，系统是如何决定哪一个视图（控件）来响应该事件呢？</p>
<p>当发生触摸事件后，系统会将该事件加入到一个由 UIApplication 管理的队列中，UIApplication 会从事件队列中取出最前面的事件，并将事件分发下去以便处理，通常，先发送事件给应用程序的主窗口。主窗口会在整个视图层次结构中找到一个最合适的视图来处理该触摸事件。找到合适的视图控件后，就会调用该控件响应的方法来处理触摸事件，常用的方法有：</p>
<p>touchesBegan...</p>
<p>touchesMoved...</p>
<p>touchesEnded...</p>
<p>touchesCancelled...</p>
<p>在app 开发中，一个控制器下通常不止一个控件，那么发生触摸事件后，哪一个控件是最合适处理该事件的呢？</p>
<p>在确定最合适控件的过程中，遵循以下原则：</p>
<p>（1）判断自己能否接收触摸事件，如果不能，直接返回；如果能，到第（2）步</p>
<p>（2）判断触摸点是否在自己身上，如果不在，直接返回；如果在，到第（3）步</p>
<p>（3）从后往前遍历子控件，重复前两步</p>
<p>（4）如果没有符合条件的子控件，那么自己就是最适合处理该触摸事件的控件。</p>
<p>举例如下：</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/490851/201512/490851-20151221203411359-2028659837.png" /></p>
<p>其中，绿色view和橙色 view都是白色view的子控件（假设先加入了绿色view，后加入了橙色view），蓝色view和红色view都是橙色view的子控件，黄色view是蓝色view的子控件。</p>
<p>当点击绿色view时，事件先传递到白色view。白色view满足条件（1），到步骤2，触摸点在自己身上，到步骤3，对橙色view做步骤（1）和步骤（2），不满足步骤（2），回退，对绿色view做步骤（1）和步骤（2），均满足，到步骤（3），没有子控件，到步骤（4），自己就是最合适的控件（绿色view）。整个的流程如下：</p>
<p>白色view ---&gt;橙色view（橙色view不满足步骤2，因此遍历绿色view）</p>
<p>----&gt;绿色view（满足步骤1和步骤2），没有子控件，所以绿色view是最适合处理该触摸事件的控件。</p>
<p>当点击黄色view时，流程如下：</p>
<p>白色view ---&gt;橙色view ---&gt;红色view（红色view覆盖了蓝色view，可知红色view是后加入的。红色view不满足条件2，因此到蓝色view）</p>
<p>---&gt;蓝色view ---&gt;黄色view(黄色view没有子控件，所以黄色view是最适合处理该触摸事件的控件)。</p>
<p>也就是说，在寻找最合适的子视图时，是从父视图控件开始，一层一层向下寻找的。</p>
<p>在找到最合适的视图控件后，就会调用控件的 touchesBegan... 等方法。这些touches的默认做法是将事件顺着响应者链条向上传递，交给上一个响应者处理。</p>
<p>假设点击了上图中的黄色控件，如果黄色控件不处理该触摸事件，会将该事件交给蓝色控件处理；如果蓝色控件不处理该控件，会将该控件交给橙色控件处理；如果橙色控件不处理该事件，会将该事件交给白色控件来处理；如果白色控件不处理该事件，白色控件会交给控制器来处理；如果控制器不处理该事件，控制器会交给主窗口处理该事件；如果主窗口不处理该事件，主窗口会交给UIApplication来处理该事件；如果UIApplication也不处理该事件，则该事件会被丢弃，不做处理。因此说，事件的处理过程是顺着响应者链条向上传递的。</p>
<p>示意图如下：</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/490851/201512/490851-20151221205322109-895445250.png" /></p>
<p>左侧是单控制器，右侧是多控制器。</p>
<p>响应者链的事件传递过程总结如下：</p>
<p>1.如果view的控制器存在，就传递给控制器处理；如果控制器不存在，则传递给它的父视图</p>
<p>2.在视图层次结构的最鼎城，如果也不能处理收到的事件，则将事件传递给window对象进行处理</p>
<p>3.如果window对象也不处理，则将事件传递给 UIApplication对象</p>
<p>4.如果UIApplication也不能处理该事件，则将该事件丢弃。</p>
<p>上传一个验证响应者链的代码（MJ所写）</p>
<p>http://files.cnblogs.com/files/acBool/06-%E5%93%8D%E5%BA%94%E8%80%85%E9%93%BE%E6%9D%A1.zip</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq14ep4q.html">C&num;中的线程&lpar;一&rpar;入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv74xoq.html">datahub</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q73e0x8.html">如何配置全世界最小的 MySQL 服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqldx309.html">新的开始&mdash;js客户端onlick无法响应</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxvn0d9.html">使用Nito&period;AsyncEx实现异步锁</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zd3j19.html">安装mysql（zip格式安装包）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn2d608.html">CSS强制文本在一行内显示若有多余字符则使用省略号表示</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm3onz9.html">SQLite及ORMlite在WebApp中的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1ljng8.html">【甘道夫】HBase基本数据操作的详细说明【完整版，精绝】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok0dep9.html">华为5700交换机通过外部开源protal和本地aaa用户认证的一些问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1znjx9.html">关于phonegap</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde2xjj9.html">DataGrid&lpar; 数据表格&rpar; 组件&lbrack;9&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wpov3q.html">Git 版本回退问题详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1dn1xq.html">Struts工作机制图&plus;OGNL&plus;EL&plus;值栈&lpar;Map&comma;对象栈&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jjleo8.html">MapReduce 规划 系列十 采用HashPartitioner调整Reducer计算负荷</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zvm2e9.html">response重定向的网址中有中文乱码的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eykzde9.html">03 ProgressBar   进度条</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwkn2k8.html">【LOJ6284】数列分块8</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2ww7pq.html">go test &colon;Wrong test signature</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwzg7z9.html">C&period; Playing Piano 动态规划</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdex6709.html">Js通过原型继承创建子类</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnxo32q.html">Python 学习日志（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ogjjj9.html">Java OCR tesseract 图像智能字符识别技术 Java实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdmzje8.html">Ubuntu使用apt-get安装本地deb包</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z2ky49.html">小心loadrunner成为瓶颈</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn10j638.html">设置Tomcat的UTF-8编码</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vlmx48.html">flash中函数的理解</a>
			</li>
						<li><a href="https://www.batexi.com/a/93xky5g9.html">Java缓存--JCS</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdxj7z8.html">李洪强iOS开发之-环信04&lowbar;消息</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z2rmz9.html">定义设置颜色的RGB值的宏</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
